/*
    This file is part of CrabEmu.

    Copyright (C) 2008 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* Thanks to Cyle Terry for the VMU icon below. */

#ifndef ICON_H
#define ICON_H

static const uint8 icon_pal[32] = {
    0x59, 0xf4, 0x69, 0xf4, 0x69, 0xf5, 0x7a, 0xf6, 
    0x8a, 0xf7, 0x8b, 0xf8, 0x9b, 0xf8, 0x9b, 0xf9, 
    0xac, 0xf9, 0xac, 0xfa, 0xbc, 0xfb, 0xcd, 0xfb, 
    0xcd, 0xfc, 0xdd, 0xfc, 0xee, 0xfd, 0xee, 0xfe
};

static const uint8 icon_img[512] = {
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xfa, 0xaf, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x97, 0xff, 
    0xff, 0xfe, 0x43, 0xbf, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xd3, 0x3d, 0xff, 
    0xff, 0xff, 0xe3, 0x07, 0xef, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xfb, 0x22, 0xdf, 0xff, 
    0xff, 0xff, 0xfd, 0x20, 0x3e, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0x70, 0x0c, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xa0, 0x04, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xfa, 0x00, 0x7f, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xf3, 0x00, 0xaf, 0xff, 0xff, 
    0xff, 0xff, 0x9f, 0xd2, 0x03, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xfd, 0x20, 0x2e, 0x9e, 0xff, 
    0xff, 0xfb, 0x9f, 0x40, 0x2d, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xa0, 0x09, 0xa9, 0xff, 
    0xff, 0xd7, 0xbc, 0x10, 0xaf, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xf7, 0x06, 0xc4, 0xff, 
    0xff, 0x86, 0x4c, 0x02, 0xac, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xfc, 0x31, 0x0a, 0x63, 0xaf, 
    0xff, 0x5c, 0x06, 0x30, 0x04, 0xaf, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xc2, 0x00, 0x3a, 0x08, 0x5f, 
    0xff, 0x89, 0xa1, 0x51, 0x00, 0x3c, 0xff, 0xfe, 
    0xef, 0xff, 0xfe, 0x20, 0x00, 0xc2, 0x4e, 0x3f, 
    0xff, 0xe0, 0x67, 0x3a, 0x10, 0x02, 0x74, 0x00, 
    0x00, 0x01, 0x43, 0x10, 0x1b, 0xb1, 0xda, 0x4f, 
    0xff, 0xfb, 0x16, 0x94, 0x74, 0x10, 0x01, 0x00, 
    0x00, 0x00, 0x00, 0x14, 0xdc, 0x4c, 0xb0, 0x8f, 
    0xff, 0xff, 0xd1, 0xcb, 0x23, 0x30, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x18, 0x31, 0xbd, 0x26, 0xff, 
    0xff, 0xff, 0xfc, 0x47, 0xc3, 0x00, 0x00, 0x00, 
    0x01, 0x00, 0x00, 0x01, 0x5e, 0xf6, 0x7f, 0xff, 
    0xff, 0xff, 0xff, 0xe7, 0x20, 0x00, 0x00, 0x10, 
    0x00, 0x10, 0x00, 0x00, 0x34, 0x28, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xa7, 0x20, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x01, 0x00, 0x02, 0x8d, 0xff, 0xff, 
    0xff, 0xff, 0xfe, 0xdc, 0xcc, 0x73, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x4a, 0xde, 0xde, 0xef, 0xff, 
    0xff, 0xe6, 0x32, 0x54, 0x43, 0x23, 0x10, 0x10, 
    0x00, 0x00, 0x03, 0x33, 0x33, 0x54, 0x03, 0x9f, 
    0xff, 0x65, 0xae, 0xff, 0xe8, 0x27, 0x20, 0x00, 
    0x00, 0x10, 0x08, 0x67, 0xff, 0xff, 0xc8, 0x4f, 
    0xff, 0x5f, 0xff, 0xff, 0xa0, 0x35, 0xad, 0xdd, 
    0xcc, 0xdc, 0xa4, 0x10, 0x4f, 0xff, 0xf9, 0xaf, 
    0xfc, 0xcf, 0xff, 0xff, 0x51, 0xaf, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xf4, 0x2d, 0xff, 0xfb, 0xff, 
    0xfe, 0xff, 0xff, 0xf8, 0x01, 0xef, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xf8, 0x02, 0xef, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xf4, 0x07, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0x20, 0xaf, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xf4, 0x07, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0x20, 0x9f, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xf7, 0x05, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0x20, 0xcf, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xfe, 0x5a, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0x66, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};

#endif /* !ICON_H */
