/*
    This file is part of CrabEmu.

    Copyright (C) 2011 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef ButtonFormatter_h
#define ButtonFormatter_h

#import <Cocoa/Cocoa.h>

/* This is taken from the Cocoa version of Yabause, which I wrote. There, this
   is called YabauseButtonFormatter, but the content is the same. */
@interface ButtonFormatter : NSFormatter {
}

- (NSString *)stringForObjectValue:(id)obj;
- (BOOL)getObjectValue:(id *)obj
             forString:(NSString *)str 
      errorDescription:(NSString **)err;

-       (BOOL)control:(NSControl*)control
             textView:(NSTextView*)textView
  doCommandBySelector:(SEL)commandSelector;

@end /* @interface ButtonFormatter */

#endif /* !ButtonFormatter_h */
