/*
	This file is part of CrabEmu.

	Copyright (C) 2005, 2006, 2007, 2008, 2009 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef EMUOGLVIEW_H
#define EMUOGLVIEW_H

#import <Cocoa/Cocoa.h>
#include <OpenGL/OpenGL.h>
#include <OpenGL/GL.h>

#include "smsvdp.h"

@class EmuController;

@interface EmuOGLView : NSOpenGLView
{
    IBOutlet EmuController *controller;
    IBOutlet NSWindow *window;
    BOOL resized;
    NSOpenGLContext *fsCxt;
    BOOL isFullscreen;
    CGDirectDisplayID disp;
    NSPoint mouseLoc;
    GLuint glTexture;
    BOOL glInitted;
    BOOL keepAspect;
    BOOL useHQ2x;
    BOOL useHQ4x;
    BOOL useScale2x;
    BOOL txrChanged;
    pixel_t *fbTrans;
    int texwidth;
    int texheight;
}

- (id)initWithFrame:(NSRect)frameRect;
- (void)dealloc;
- (void)renderScene;
- (void)drawRect:(NSRect)rect;
- (BOOL)acceptsFirstResponder;
- (void)showWindow;
- (void)keyDown:(NSEvent *)event;
- (void)keyUp:(NSEvent *)event;
- (void)mouseDown:(NSEvent *)event;
- (void)mouseUp:(NSEvent *)event;
- (void)mouseDragged:(NSEvent *)event;
- (float)width;
- (float)height;
- (void)setAspectRatioX:(float)x Y:(float)y;
- (void)update;
- (void)setTitle:(NSString *)str;
- (BOOL)isFullscreen;
- (void)toggleFullscreen;
- (CGDirectDisplayID)screenID;
- (void)createFullscreenContext;
- (void)setKeepAspect:(BOOL)ka;
- (void)setRenderer:(int)renderer;

@end

#endif
