/*
    This file is part of CrabEmu.

    Copyright (C) 2009 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CRABEMU_NSCONDITION_H
#define CRABEMU_NSCONDITION_H

/* Cocoa has had this class since Mac OS X 10.0, according to various sources,
   but the functionality wasn't exposed in a public header until Mac OS X 10.5.
   So, if compiling for 10.4 or earlier (which I currently am), the class needs
   to be defined. */

#if MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5
#include <Foundation/NSLock.h>
#else

#include <Foundation/NSObject.h>
#include <Foundation/NSLock.h>

@interface NSCondition : NSObject <NSLocking>
{
@private
    void *_priv;
}

- (void) wait;
- (BOOL) waitUntilDate:(NSDate*)limit;
- (void) signal;
- (void) broadcast;
@end

#endif

#endif /* !CRABEMU_NSCONDITION_H */
