/*
    This file is part of CrabEmu.

    Copyright (C) 2009 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef OPENGLFONT_H
#define OPENGLFONT_H

#import <Cocoa/Cocoa.h>
#include <OpenGL/GL.h>

@interface OpenGLFont : NSObject
{
    NSFont *font;
    GLuint *chars;
    NSSize *sizes;
    NSPoint *uvs;
}

- (id)initWithFont:(NSFont *)f;
- (void)dealloc;
- (void)drawString:(NSString *)str at:(NSPoint)pt red:(float)r green:(float)g
              blue:(float)b alpha:(float)a;
- (NSPoint)drawCharacter:(char)ch at:(NSPoint)pt red:(float)r green:(float)g
                    blue:(float)b alpha:(float)a;
- (void)drawString:(NSString *)str at:(NSPoint)pt red:(float)r green:(float)g
              blue:(float)b alpha:(float)a bgRed:(float)bgr bgGreen:(float)bgg
            bgBlue:(float)bgb bgAlpha:(float)bga;
- (NSPoint)drawCharacter:(char)ch at:(NSPoint)pt red:(float)r green:(float)g
                    blue:(float)b alpha:(float)a bgRed:(float)bgr
                 bgGreen:(float)bgg bgBlue:(float)bgb bgAlpha:(float)bga;
- (NSSize)metricsForCharacter:(char)ch;

@end

#endif /* !OPENGLFONT_H */
