/*
    This file is part of CrabEmu.

    Copyright (C) 2008 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#import "SMSVDPDebugController.h"
#include "smsvdp.h"

extern SMSVDPDebugController *vdpDebugger;

@implementation SMSVDPDebugController

- (void)awakeFromNib
{
    vdpDebugger = self;
}

- (void)update
{
    char string[5];

    sprintf(string, "%02X", smsvdp.regs[0]);
    [register0 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[1]);
    [register1 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[2]);
    [register2 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[3]);
    [register3 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[4]);
    [register4 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[5]);
    [register5 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[6]);
    [register6 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[7]);
    [register7 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[8]);
    [register8 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[9]);
    [register9 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[10]);
    [register10 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[11]);
    [register11 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[12]);
    [register12 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[13]);
    [register13 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[14]);
    [register14 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.regs[15]);
    [register15 setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%01d", smsvdp.code);
    [codeRegister setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%04X", smsvdp.addr);
    [addressRegister setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.status);
    [statusRegister setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.read_buf);
    [readBuffer setStringValue: [NSString stringWithUTF8String: string]];

    sprintf(string, "%02X", smsvdp.v_scroll);
    [vScrollLatch setStringValue: [NSString stringWithUTF8String: string]];

    if(smsvdp.flags & 0x01)
        [flags1stByte setState: NSOnState];
    else
        [flags1stByte setState: NSOffState];

    if(smsvdp.flags & 0x02)
        [flagsVScroll setState: NSOnState];
    else
        [flagsVScroll setState: NSOffState];

    if(smsvdp.flags & 0x04)
        [flagsLineInt setState: NSOnState];
    else
        [flagsLineInt setState: NSOffState];
}

@end
