/*
    This file is part of CrabEmu.

    Copyright (C) 2006 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#import <Cocoa/Cocoa.h>

@interface Z80DebugController : NSObject
{
    IBOutlet NSTextField *currentInstruction;
    IBOutlet NSTextField *cyclesToGo;
    IBOutlet NSTextField *scanlineNumber;
    IBOutlet NSButton *flagsC;
    IBOutlet NSButton *flagsH;
    IBOutlet NSButton *flagsN;
    IBOutlet NSButton *flagsP;
    IBOutlet NSButton *flagsS;
    IBOutlet NSButton *flagsX;
    IBOutlet NSButton *flagsY;
    IBOutlet NSButton *flagsZ;
    IBOutlet NSTextField *regAF;
    IBOutlet NSTextField *regAFp;
    IBOutlet NSTextField *regBC;
    IBOutlet NSTextField *regBCp;
    IBOutlet NSTextField *regDE;
    IBOutlet NSTextField *regDEp;
    IBOutlet NSTextField *regHL;
    IBOutlet NSTextField *regHLp;
    IBOutlet NSTextField *regIR;
    IBOutlet NSTextField *regIX;
    IBOutlet NSTextField *regIY;
    IBOutlet NSTextField *regPC;
    IBOutlet NSTextField *regSP;
    IBOutlet NSButton *singleStep;
    IBOutlet NSButton *stateHalted;
    IBOutlet NSButton *stateIFF1;
    IBOutlet NSButton *stateIFF2;
}

- (void)updateWithCycles:(int)cycles scanline:(int)scanline;
- (IBAction)singleStep:(id)sender;
- (IBAction)runFrame:(id)sender;
- (IBAction)runScanline:(id)sender;

@end
