/*
    This file is part of CrabEmu.

    Copyright (C) 2009 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CRABEMUTHREAD_H
#define CRABEMUTHREAD_H

#include <QThread>

class CrabEmuThread : public QThread {
        Q_OBJECT

    public:
        CrabEmuThread(QObject *parent = NULL);
        ~CrabEmuThread();

        void restart();
        void finish();
        void setFps(float f);

    signals:
        void frameRendered();

    protected:
        void run();

    private:
        int finished;
        float fps;
};

#endif /* !CRABEMUTHREAD_H */
