/*
    This file is part of CrabEmu

    Copyright (C) 2009,2011,2012 Harley Laue

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef UIDEBUGWINDOW_H
#define UIDEBUGWINDOW_H

#include <QMainWindow>
#include "ui_DebugWindow.h"

class CrabEmuThread;
class UICrabEmu;

class UIDebugWindow : public QMainWindow, public Ui::DebugWindow {
        Q_OBJECT

    public:
        UIDebugWindow(CrabEmuThread *thd, UICrabEmu* parent = 0, bool paused = false);
        void restoreSettings();
        void updateSDSC(const char console[25][80 * 2]);

    protected:
        void closeEvent(QCloseEvent *event);
        void setCpuInfo();
        void setVdpInfo();
        void setVdpTiles();
        void setSndInfo();
        void disassemble();
        void updatePalette();
        void setSDSC();
        void resetSDSC();

    protected slots:
        void on_actionPause_triggered();
        void on_actionCPUStep_triggered();
        void on_actionFrameStep_triggered();
        void on_actionRunToCursor_triggered();
        void on_actionReset_triggered();
        void on_actionReloadRom_triggered();
        void on_main_pause(bool pause);
        void update();

    signals:
        void togglePaused();
        void reset();
        void reloadRom();

    private:
        UICrabEmu *parent;
        bool paused;
        bool sdscUpdated;
        char sdscData[25][80 * 2];
};

#endif // UIDEBUGWINDOW_H
