/*
    This file is part of CrabEmu.

    Copyright (C) 2009, 2013 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef UIPREFERENCES_H
#define UIPREFERENCES_H

#include <QSettings>

#include "ui_Preferences.h"
#include "sms.h"

class UIPreferences : public QDialog, public Ui::PreferencesDialog {
        Q_OBJECT

    public:
        UIPreferences(QWidget *parent = NULL);
        void updatePreferences();

    protected slots:
        void on_buttonSMS1Up_clicked();
        void on_buttonSMS1Down_clicked();
        void on_buttonSMS1Left_clicked();
        void on_buttonSMS1Right_clicked();
        void on_buttonSMS1A_clicked();
        void on_buttonSMS1B_clicked();

        void on_buttonSMS2Up_clicked();
        void on_buttonSMS2Down_clicked();
        void on_buttonSMS2Left_clicked();
        void on_buttonSMS2Right_clicked();
        void on_buttonSMS2A_clicked();
        void on_buttonSMS2B_clicked();

        void on_buttonGGStart_clicked();

        // ColecoVision buttons
        void on_buttonColeco1Up_clicked();
        void on_buttonColeco1Down_clicked();
        void on_buttonColeco1Left_clicked();
        void on_buttonColeco1Right_clicked();
        void on_buttonColeco1LAction_clicked();
        void on_buttonColeco1RAction_clicked();
        void on_buttonColeco1one_clicked();
        void on_buttonColeco1two_clicked();
        void on_buttonColeco1three_clicked();
        void on_buttonColeco1four_clicked();
        void on_buttonColeco1five_clicked();
        void on_buttonColeco1six_clicked();
        void on_buttonColeco1seven_clicked();
        void on_buttonColeco1eight_clicked();
        void on_buttonColeco1nine_clicked();
        void on_buttonColeco1star_clicked();
        void on_buttonColeco1zero_clicked();
        void on_buttonColeco1pound_clicked();

        void on_buttonColeco2Up_clicked();
        void on_buttonColeco2Down_clicked();
        void on_buttonColeco2Left_clicked();
        void on_buttonColeco2Right_clicked();
        void on_buttonColeco2LAction_clicked();
        void on_buttonColeco2RAction_clicked();
        void on_buttonColeco2one_clicked();
        void on_buttonColeco2two_clicked();
        void on_buttonColeco2three_clicked();
        void on_buttonColeco2four_clicked();
        void on_buttonColeco2five_clicked();
        void on_buttonColeco2six_clicked();
        void on_buttonColeco2seven_clicked();
        void on_buttonColeco2eight_clicked();
        void on_buttonColeco2nine_clicked();
        void on_buttonColeco2star_clicked();
        void on_buttonColeco2zero_clicked();
        void on_buttonColeco2pound_clicked();

        // NES Buttons
        void on_buttonNES1Up_clicked();
        void on_buttonNES1Down_clicked();
        void on_buttonNES1Left_clicked();
        void on_buttonNES1Right_clicked();
        void on_buttonNES1A_clicked();
        void on_buttonNES1B_clicked();
        void on_buttonNES1Start_clicked();
        void on_buttonNES1Select_clicked();

        void on_buttonNES2Up_clicked();
        void on_buttonNES2Down_clicked();
        void on_buttonNES2Left_clicked();
        void on_buttonNES2Right_clicked();
        void on_buttonNES2A_clicked();
        void on_buttonNES2B_clicked();
        void on_buttonNES2Start_clicked();
        void on_buttonNES2Select_clicked();

        void on_buttonBrowseSMSBios_clicked();
        void on_buttonBrowseGGBios_clicked();
        void on_buttonBrowseCVBios_clicked();

        void on_buttonBrowseSave_clicked();
        void on_buttonBrowseState_clicked();
        void on_buttonBrowseCheat_clicked();

    private:
        int getKeyInput();
        void setKey(const char *buttonmap, const char *button,
                    int console = CONSOLE_SMS);
        void openDialog(const char *caption, const char *filter,
                        QLineEdit *line);
        void openDirectory(const char *caption, QLineEdit *line);

        QVariantMap sms_bm, coleco_bm, nes_bm;
};

#endif /* !UIPREFERENCES_H */
