/*
    This file is part of CrabEmu.

    Copyright (C) 2011 Harley Laue

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef CONFIG_H
#define CONFIG_H

enum Config {
    WIDTH,
    HEIGHT,
    ACTUAL_SIZE,
    PSG76489_ENABLED,
    YM2413_ENABLED,
    DELAY,
    REGION,
    VIDEOMODE,
    /* Add non-input above this */
    PAD1_UP,
    PAD1_DOWN,
    PAD1_LEFT,
    PAD1_RIGHT,
    PAD1_1,
    PAD1_2,
    PAD2_UP,
    PAD2_DOWN,
    PAD2_LEFT,
    PAD2_RIGHT,
    PAD2_1,
    PAD2_2, /* this is used as the last player input key */
    COLECO1_UP,
    COLECO1_DOWN,
    COLECO1_LEFT,
    COLECO1_RIGHT,
    COLECO1_LACTION,
    COLECO1_RACTION,
    COLECO1_1,
    COLECO1_2,
    COLECO1_3,
    COLECO1_4,
    COLECO1_5,
    COLECO1_6,
    COLECO1_7,
    COLECO1_8,
    COLECO1_9,
    COLECO1_STAR,
    COLECO1_0,
    COLECO1_POUND,
    COLECO2_UP,
    COLECO2_DOWN,
    COLECO2_LEFT,
    COLECO2_RIGHT,
    COLECO2_LACTION,
    COLECO2_RACTION,
    COLECO2_1,
    COLECO2_2,
    COLECO2_3,
    COLECO2_4,
    COLECO2_5,
    COLECO2_6,
    COLECO2_7,
    COLECO2_8,
    COLECO2_9,
    COLECO2_STAR,
    COLECO2_0,
    COLECO2_POUND,
    GG_PAUSE, /* this is used as the first "system" key */
    SMS_PAUSE,
    QUIT_BUTTON,
    MUTE_BUTTON,
    /* Add int cfg values above this */
    CONFIG_INT_SIZE,
    /* all below are string values */
    RENDERER,
    SCALER,
    SMS_BIOS_DIR,
    GG_BIOS_DIR,
    COLECO_BIOS_DIR,
    SAVE_STATE_DIR,
    SRAM_DIR,
    ROM_DIR,
    DEFAULT_ROM,
    FONT_FILE,
    CONFIG_SIZE
};

int config_open(char *filename);
void config_open_local(char *filename);
void config_close();

char *config_default_filename();

const char *config_get_str(enum Config c);
int config_get_int(enum Config c);

#endif
